// PWMDual.h
// Runs on TM4C123

// Please note:
/*
   This is a modified version from original Jonathan Valvano's routine
	 
	 This is an example routine I prepared to handle a hobby servo motor 
	 by PWM tested with a EK-TM4C123GXL board TM4C123.
	 Connections are:
	 PB6 is for PWM input on servo motor
	 Tested with a standard Tower Pro MG90S Micro servo motor
	 where 20 milliseconds is the standard period for the PWM input
	 0.9 ms is for +90 position
	 1.65 ms is for 0 position
	 2.4 ms is for -90  position
	 by Francisco Dominguez Roman 2014 Twitter: @Franciscodr
	 blog http://www.gestionconsult.es/blog/
	 more information of robotics at http://letsmakerobots.com/content/lets-learn-basics-robotics-edxs-embedded-systems-shape-world
	 and http://e2e.ti.com/support/microcontrollers/tiva_arm/f/908/p/342633/1201161.aspx

*/ 

// Old documentation from original version of this routine before adaptation to servo control

// Use PWM0/PB6 and PWM1/PB7 to generate two square waves with 50% duty cycle
// and 180 degrees out of phase.
// Daniel Valvano
// September 10, 2013

/* This example accompanies the book
   "Embedded Systems: Real Time Interfacing to ARM Cortex M Microcontrollers",
   ISBN: 978-1463590154, Jonathan Valvano, copyright (c) 2013
  Program 6.7, section 6.3.2

 Copyright 2013 by Jonathan W. Valvano, valvano@mail.utexas.edu
    You may use, edit, run or distribute this file
    as long as the above copyright notice remains
 THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 VALVANO SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 For more information about my classes, my research, and my books, see
 http://users.ece.utexas.edu/~valvano/
 */

// initialize PWM1-0, 50 Hz,  20 ms for servo control

// OLD DOCUMENTATION (still valid) -V
// period is 16-bit number of PWM clock cycles in one period (3<=period)
// PWM clock rate = processor clock rate/SYSCTL_RCC_PWMDIV
//                = BusClock/64 
//                = 3.2 MHz/64 = 50 kHz (in this example)
// END OLD DOCUMENTATION -^

void PWM0Dual_Init(unsigned long period, unsigned short dcpwm0,  unsigned short dcpwm1);
	
	
	/*
 Main PWM function call
 PWM0Dual_Period (dcpwm0,dcpwm1) 
 where dcpwm0 and dcpwm1 go from 0 to 65535
 change of dcpwm1 is not recomended as affects main PWM output
 so keep dcpwm1 at zero value
	
This values are based on real test and calculations derived from them
for Duty Cycle at "dcpwm0" value at "PWM0Dual_Period" PWM output function

Position 
of servo in     Calculated 
Degrees	        positions
   0	  ---------- 2100  (or +90 as said above)
   45   ---------- 3466
   90   ---------- 4833  (or  0 as said above)
   135  ---------- 6199
   180	---------- 7565  (or -90 as said above)
	 
1 degree ----------	 30

65535 is the maximum value for dcpwm0 and dcpwm1

		*/
		
// OLD DOCUMENTATION -V
// change period
// period is 16-bit number of PWM clock cycles in one period (3<=period)
// dcpwm0 Duty Cycle for PB6
// dcpwm1 Duty Cycle for PB7
// END OLD DOCUMENTATION -^


void PWM0Dual_Period(unsigned short dcpwm0, unsigned short dcpwm1);
